from helpers import BetapicPrior, train_betapic, BetapicSimulator
from lampe.data import H5Dataset
from orbitize import DATADIR, read_input
import torch.nn as nn
import zuko 
import argparse
import wandb
from orbitize import read_input, DATADIR
from orbitize.system import seppa2radec, transform_errors
from lampe.data import H5Dataset, JointLoader

def main(size):
    
    # à enlever plus tard
    data_table = read_input.read_file('{}/betaPic.csv'.format(DATADIR))

    data_table = data_table[:-1] 

    ra_errs = []
    dec_errs = []
    corrs = []
    ra, dec = seppa2radec(data_table["quant1"], data_table["quant2"])

    for i in range(len(data_table)):
        ra_err, dec_err, corr = transform_errors(data_table["quant1"][i], 
                                                data_table["quant2"][i], 
                                                data_table["quant1_err"][i], 
                                                data_table["quant2_err"][i], 
                                                data_table["quant12_corr"][i], 
                                                seppa2radec)
        ra_errs.append(ra_err)
        dec_errs.append(dec_err)
        corrs.append(corr)

    data_table["quant1"] = ra
    data_table["quant2"] = dec
    data_table["quant1_err"] = ra_errs
    data_table["quant2_err"] = dec_errs
    data_table["quant12_corr"] = corr
    data_table["quant_type"] = ["radec" for _ in range(len(data_table))]

#     trainset = H5Dataset(f'datasets/betapic_{size}-train.h5', batch_size=2048, shuffle=True).to_memory() 
#     validset = H5Dataset(f'datasets/betapic_{size}-val.h5', batch_size=2048, shuffle=True).to_memory()
#     trainset = H5Dataset(f'datasets/betapic-adpi-train.h5', batch_size=2048, shuffle=True).to_memory()
#     validset = H5Dataset(f'datasets/betapic-adpi-val.h5', batch_size=2048, shuffle=True).to_memory()  
    
    #priors = BetapicPrior() # Needed to post-process the data in the training phase
    LOWER = [4.0, 1e-5, 180.0, 0.0, 0.0, 0.0, 100.0, 0.2]
    UPPER = [100.0, 0.99, 0.0, 360.0, 360.0, 1.0, 100.0, 3.0]

    priors = Prior(LOWER, UPPER) 
    simulator = BetapicSimulator(data_table)

    trainset = JointLoader(priors, simulator, batch_size=2048, vectorized=True)
    validset = JointLoader(priors, simulator, batch_size=2048, vectorized=True)
    
    num_obs = 2*(len(read_input.read_file('{}/betaPic.csv'.format(DATADIR))) - 1) # The RV observation is discarded
    #num_obs = 18*2
    wandb.login()
    train_betapic(
        trainset=trainset,
        validset=validset,
        prior=priors,
        epochs=512,
        NPE_hidden_features=[512] * 5,
        flow = zuko.flows.spline.NSF, #,
        transforms = 3,
        num_obs=num_obs,
    )   

if __name__ == '__main__':
    
    parser = argparse.ArgumentParser(description="Train betapic model")
    parser.add_argument("--size", type=int, default=23, help="The exponent of 2 for the training dataset size")
    args = parser.parse_args()

    main(args.size)
